#include <mpi.h>
#include <stdio.h>

#define WRAPPER_ENTER() printf("[C Wrapper] Enter %s\n", __func__)
#define WRAPPER_EXIT() printf("[C Wrapper] Exit %s\n", __func__)


int
MPI_Send( const void* buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm )
{
    WRAPPER_ENTER();
    int return_value;
    return_value = PMPI_Send( buf, count, datatype, dest, tag, comm );
    WRAPPER_EXIT();

    return return_value;
}


int
MPI_Irecv( void*        buf,
           int          count,
           MPI_Datatype datatype,
           int          source,
           int          tag,
           MPI_Comm     comm,
           MPI_Request* request )
{
    WRAPPER_ENTER();
    int return_value;
    return_value = PMPI_Irecv( buf, count, datatype, source, tag, comm, request );
    WRAPPER_EXIT();

    return return_value;
}

int
MPI_Wait( MPI_Request* request,
          MPI_Status*  status )
{
    WRAPPER_ENTER();
    int return_value;
    return_value = PMPI_Wait( request, status );
    WRAPPER_EXIT();

    return return_value;
}
