#define CHOICE_BUFFER_TYPE type(*), dimension(..)

#define F08_SYMBOL_NAME_MPI_SEND mpi_send_f08ts
#define F08_SYMBOL_NAME_MPI_IRECV mpi_irecv_f08ts
#define F08_SYMBOL_NAME_MPI_WAIT mpi_wait_f08

subroutine F08_SYMBOL_NAME_MPI_SEND( &
    buf, &
    count, &
    datatype, &
    dest, &
    tag, &
    comm, &
    ierror)

    use :: mpi_f08, only: &
        MPI_COMM, &
        MPI_DATATYPE, &
        MPI_PROC_NULL, &
        PMPI_Send, &
        PMPI_Type_size

    implicit none

! Dummy argument declarations
    CHOICE_BUFFER_TYPE, INTENT(IN) :: buf
    INTEGER, INTENT(IN) :: count
    TYPE(MPI_DATATYPE), INTENT(IN) :: datatype
    INTEGER, INTENT(IN) :: dest
    INTEGER, INTENT(IN) :: tag
    TYPE(MPI_COMM), INTENT(IN) :: comm
    INTEGER, INTENT(OUT), OPTIONAL :: ierror
! Internal replacements for dummy arguments
    INTEGER :: internal_ierror

    print *, "[F08 Wrapper] Enter MPI_Send"
    call PMPI_Send( &
        buf, &
        count, &
        datatype, &
        dest, &
        tag, &
        comm, &
        internal_ierror)
    print *, "[F08 Wrapper] Exit MPI_Send"

    if (present(ierror)) then
        ierror = internal_ierror
    end if
end subroutine


subroutine F08_SYMBOL_NAME_MPI_IRECV( &
    buf, &
    count, &
    datatype, &
    source, &
    tag, &
    comm, &
    request, &
    ierror)

    use :: mpi_f08, only: &
        MPI_COMM, &
        MPI_DATATYPE, &
        MPI_PROC_NULL, &
        MPI_REQUEST, &
        MPI_SUCCESS, &
        PMPI_Irecv, &
        PMPI_Type_size

    implicit none

! Dummy argument declarations
    CHOICE_BUFFER_TYPE, ASYNCHRONOUS :: buf
    INTEGER, INTENT(IN) :: count
    TYPE(MPI_DATATYPE), INTENT(IN) :: datatype
    INTEGER, INTENT(IN) :: source
    INTEGER, INTENT(IN) :: tag
    TYPE(MPI_COMM), INTENT(IN) :: comm
    TYPE(MPI_REQUEST), INTENT(OUT) :: request
    INTEGER, INTENT(OUT), OPTIONAL :: ierror
! Internal replacements for dummy arguments
    INTEGER :: internal_ierror

    print *, "[F08 Wrapper] Enter MPI_Irecv"
    call PMPI_Irecv( &
        buf, &
        count, &
        datatype, &
        source, &
        tag, &
        comm, &
        request, &
        internal_ierror)
    print *, "[F08 Wrapper] Exit MPI_Irecv"

    if (present(ierror)) then
        ierror = internal_ierror
    end if
end subroutine

subroutine F08_SYMBOL_NAME_MPI_WAIT( &
    request, &
    status, &
    ierror)

    use :: mpi_f08, only: &
        MPI_REQUEST, &
        MPI_STATUS, &
        PMPI_Wait

    implicit none

! Dummy argument declarations
    TYPE(MPI_REQUEST), INTENT(INOUT) :: request
    TYPE(MPI_STATUS), TARGET :: status
    INTEGER, INTENT(OUT), OPTIONAL :: ierror
! Internal replacements for dummy arguments
    INTEGER :: internal_ierror

    print *, "[F08 Wrapper] Enter MPI_Wait"
    call PMPI_Wait( &
        request, &
        status, &
        internal_ierror)
    print *, "[F08 Wrapper] Exit MPI_Wait"

    if (present(ierror)) then
        ierror = internal_ierror
    end if
end subroutine
